﻿Public Class Form1

    Const GPIO_OK As Integer = 0
    Const GPIO_INVALID_HANDLE As Integer = 1
    Const GPIO_IO_ERROR As Integer = 2
    Const GPIO_INVALID_PARAMETER As Integer = 3
    Const GPIO_OTHER_ERROR As Integer = 4
    Const GPIO_H_LEVEL As Integer = 5
    Const GPIO_L_LEVEL As Integer = 6

    Private Declare Function ScanIF Lib "gpio.dll" Alias "?GPIO_ScanInterface@@YGKPAI@Z" (ByRef puiNumber As Integer) As Integer
    Private Declare Function OpenIF Lib "gpio.dll" Alias "?GPIO_OpenInterface@@YGKIPAPAX@Z" (ByVal uiInterface As Integer, ByRef gpioHandle As Integer) As Integer
    Private Declare Function CloseIF Lib "gpio.dll" Alias "?GPIO_CloseInterface@@YGKPAX@Z" (ByVal gpioHandle As Integer) As Integer
    Private Declare Function Input Lib "gpio.dll" Alias "?GPIO_Input@@YGKPAXDPAE@Z" (ByVal gpioHandle As Integer, ByVal cPort As Byte, ByRef pucData As Byte) As Integer
    Private Declare Function Output Lib "gpio.dll" Alias "?GPIO_Output@@YGKPAXDE@Z" (ByVal gpioHandle As Integer, ByVal cPort As Byte, ByVal ucData As Byte) As Integer
    Private Declare Function BitTest Lib "gpio.dll" Alias "?GPIO_BitTest@@YGKPAXDE@Z" (ByVal gpioHandle As Integer, ByVal cPort As Byte, ByVal ucBit As Byte) As Integer
    Private Declare Function BitSet Lib "gpio.dll" Alias "?GPIO_BitSet@@YGKPAXDE@Z" (ByVal gpioHandle As Integer, ByVal cPort As Byte, ByVal ucBit As Byte) As Integer
    Private Declare Function BitReset Lib "gpio.dll" Alias "?GPIO_BitReset@@YGKPAXDE@Z" (ByVal gpioHandle As Integer, ByVal cPort As Byte, ByVal ucBit As Byte) As Integer

    Dim ifNumber As Integer                     'インターフェース数
    Dim ifHndl As Integer                       'インターフェースハンドル

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim stc As Integer                      'ステータスコード

        stc = ScanIF(ifNumber)                  'インターフェースをスキャン
        If (ifNumber > 0) Then
            stc = OpenIF(0, ifHndl)             '最初のインターフェースをオープン
            If (stc = GPIO_OK) And (ifHndl <> 0) Then
                stc = Output(ifHndl, Asc("C"), 0)    'ポートＣ初期化
                stc = Output(ifHndl, Asc("D"), 0)    'ポートＤ初期化
                Timer1.Enabled = True
            End If
        End If

    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Dim stc As Integer                      'ステータスコード
        Dim dt As Byte

        stc = Input(ifHndl, Asc("A"), dt)            'ポートＡ読み取り

        If (dt And &H1) Then
            Panel1.BackColor = Color.LightGreen
        Else
            Panel1.BackColor = Color.DarkRed
        End If

        If (dt And &H2) Then
            Panel2.BackColor = Color.LightGreen
        Else
            Panel2.BackColor = Color.DarkRed
        End If

        If (dt And &H4) Then
            Panel3.BackColor = Color.LightGreen
        Else
            Panel3.BackColor = Color.DarkRed
        End If

        If (dt And &H8) Then
            Panel4.BackColor = Color.LightGreen
        Else
            Panel4.BackColor = Color.DarkRed
        End If

        If (dt And &H10) Then
            Panel5.BackColor = Color.LightGreen
        Else
            Panel5.BackColor = Color.DarkRed
        End If

        If (dt And &H20) Then
            Panel6.BackColor = Color.LightGreen
        Else
            Panel6.BackColor = Color.DarkRed
        End If

        If (dt And &H40) Then
            Panel7.BackColor = Color.LightGreen
        Else
            Panel7.BackColor = Color.DarkRed
        End If

        If (dt And &H80) Then
            Panel8.BackColor = Color.LightGreen
        Else
            Panel8.BackColor = Color.DarkRed
        End If

        stc = Input(ifHndl, Asc("B"), dt)            'ポートＢ読み取り

        If (dt And &H1) Then
            Panel9.BackColor = Color.LightGreen
        Else
            Panel9.BackColor = Color.DarkRed
        End If

        If (dt And &H2) Then
            Panel10.BackColor = Color.LightGreen
        Else
            Panel10.BackColor = Color.DarkRed
        End If

        If (dt And &H4) Then
            Panel11.BackColor = Color.LightGreen
        Else
            Panel11.BackColor = Color.DarkRed
        End If

        If (dt And &H8) Then
            Panel12.BackColor = Color.LightGreen
        Else
            Panel12.BackColor = Color.DarkRed
        End If

        If (dt And &H10) Then
            Panel13.BackColor = Color.LightGreen
        Else
            Panel13.BackColor = Color.DarkRed
        End If

        If (dt And &H20) Then
            Panel14.BackColor = Color.LightGreen
        Else
            Panel14.BackColor = Color.DarkRed
        End If

        If (dt And &H40) Then
            Panel15.BackColor = Color.LightGreen
        Else
            Panel15.BackColor = Color.DarkRed
        End If

        If (dt And &H80) Then
            Panel16.BackColor = Color.LightGreen
        Else
            Panel16.BackColor = Color.DarkRed
        End If

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitReset(ifHndl, Asc("C"), 0)
        OvalShape1.BackColor = Color.DarkRed
        Button1.Enabled = False
        Button2.Enabled = True

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitSet(ifHndl, Asc("C"), 0)
        OvalShape1.BackColor = Color.LightGreen
        Button1.Enabled = True
        Button2.Enabled = False

    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitReset(ifHndl, Asc("C"), 1)
        OvalShape2.BackColor = Color.DarkRed
        Button3.Enabled = False
        Button4.Enabled = True

    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitSet(ifHndl, Asc("C"), 1)
        OvalShape2.BackColor = Color.LightGreen
        Button3.Enabled = True
        Button4.Enabled = False

    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitReset(ifHndl, Asc("C"), 2)
        OvalShape3.BackColor = Color.DarkRed
        Button5.Enabled = False
        Button6.Enabled = True

    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitSet(ifHndl, Asc("C"), 2)
        OvalShape3.BackColor = Color.LightGreen
        Button5.Enabled = True
        Button6.Enabled = False

    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitReset(ifHndl, Asc("C"), 3)
        OvalShape4.BackColor = Color.DarkRed
        Button7.Enabled = False
        Button8.Enabled = True

    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitSet(ifHndl, Asc("C"), 3)
        OvalShape4.BackColor = Color.LightGreen
        Button7.Enabled = True
        Button8.Enabled = False

    End Sub

    Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitReset(ifHndl, Asc("C"), 4)
        OvalShape5.BackColor = Color.DarkRed
        Button9.Enabled = False
        Button10.Enabled = True

    End Sub

    Private Sub Button10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitSet(ifHndl, Asc("C"), 4)
        OvalShape5.BackColor = Color.LightGreen
        Button9.Enabled = True
        Button10.Enabled = False

    End Sub

    Private Sub Button11_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button11.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitReset(ifHndl, Asc("C"), 5)
        OvalShape6.BackColor = Color.DarkRed
        Button11.Enabled = False
        Button12.Enabled = True

    End Sub

    Private Sub Button12_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button12.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitSet(ifHndl, Asc("C"), 5)
        OvalShape6.BackColor = Color.LightGreen
        Button11.Enabled = True
        Button12.Enabled = False

    End Sub

    Private Sub Button13_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button13.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitReset(ifHndl, Asc("C"), 6)
        OvalShape7.BackColor = Color.DarkRed
        Button13.Enabled = False
        Button14.Enabled = True

    End Sub

    Private Sub Button14_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button14.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitSet(ifHndl, Asc("C"), 6)
        OvalShape7.BackColor = Color.LightGreen
        Button13.Enabled = True
        Button14.Enabled = False

    End Sub

    Private Sub Button15_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button15.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitReset(ifHndl, Asc("C"), 7)
        OvalShape8.BackColor = Color.DarkRed
        Button15.Enabled = False
        Button16.Enabled = True

    End Sub

    Private Sub Button16_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button16.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitSet(ifHndl, Asc("C"), 7)
        OvalShape8.BackColor = Color.LightGreen
        Button15.Enabled = True
        Button16.Enabled = False

    End Sub

    Private Sub Button17_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button17.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitReset(ifHndl, Asc("D"), 0)
        OvalShape9.BackColor = Color.DarkRed
        Button17.Enabled = False
        Button18.Enabled = True

    End Sub

    Private Sub Button18_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button18.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitSet(ifHndl, Asc("D"), 0)
        OvalShape9.BackColor = Color.LightGreen
        Button17.Enabled = True
        Button18.Enabled = False

    End Sub

    Private Sub Button19_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button19.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitReset(ifHndl, Asc("D"), 1)
        OvalShape10.BackColor = Color.DarkRed
        Button19.Enabled = False
        Button20.Enabled = True

    End Sub

    Private Sub Button20_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button20.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitSet(ifHndl, Asc("D"), 1)
        OvalShape10.BackColor = Color.LightGreen
        Button19.Enabled = True
        Button20.Enabled = False

    End Sub

    Private Sub Button21_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button21.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitReset(ifHndl, Asc("D"), 2)
        OvalShape11.BackColor = Color.DarkRed
        Button21.Enabled = False
        Button22.Enabled = True

    End Sub

    Private Sub Button22_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button22.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitSet(ifHndl, Asc("D"), 2)
        OvalShape11.BackColor = Color.LightGreen
        Button21.Enabled = True
        Button22.Enabled = False

    End Sub

    Private Sub Button23_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button23.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitReset(ifHndl, Asc("D"), 3)
        OvalShape12.BackColor = Color.DarkRed
        Button23.Enabled = False
        Button24.Enabled = True

    End Sub

    Private Sub Button24_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button24.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitSet(ifHndl, Asc("D"), 3)
        OvalShape12.BackColor = Color.LightGreen
        Button23.Enabled = True
        Button24.Enabled = False

    End Sub

    Private Sub Button25_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button25.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitReset(ifHndl, Asc("D"), 4)
        OvalShape13.BackColor = Color.DarkRed
        Button25.Enabled = False
        Button26.Enabled = True

    End Sub

    Private Sub Button26_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button26.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitSet(ifHndl, Asc("D"), 4)
        OvalShape13.BackColor = Color.LightGreen
        Button25.Enabled = True
        Button26.Enabled = False

    End Sub

    Private Sub Button27_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button27.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitReset(ifHndl, Asc("D"), 5)
        OvalShape14.BackColor = Color.DarkRed
        Button27.Enabled = False
        Button28.Enabled = True

    End Sub

    Private Sub Button28_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button28.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitSet(ifHndl, Asc("D"), 5)
        OvalShape14.BackColor = Color.LightGreen
        Button27.Enabled = True
        Button28.Enabled = False

    End Sub

    Private Sub Button29_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button29.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitReset(ifHndl, Asc("D"), 6)
        OvalShape15.BackColor = Color.DarkRed
        Button29.Enabled = False
        Button30.Enabled = True

    End Sub

    Private Sub Button30_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button30.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitSet(ifHndl, Asc("D"), 6)
        OvalShape15.BackColor = Color.LightGreen
        Button29.Enabled = True
        Button30.Enabled = False

    End Sub

    Private Sub Button31_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button31.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitReset(ifHndl, Asc("D"), 7)
        OvalShape16.BackColor = Color.DarkRed
        Button31.Enabled = False
        Button32.Enabled = True

    End Sub

    Private Sub Button32_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button32.Click

        Dim stc As Integer                      'ステータスコード

        stc = BitSet(ifHndl, Asc("D"), 7)
        OvalShape16.BackColor = Color.LightGreen
        Button31.Enabled = True
        Button32.Enabled = False

    End Sub
End Class
